Index: uspace/lib/c/arch/sparc64/Makefile.inc
===================================================================
--- uspace/lib/c/arch/sparc64/Makefile.inc	(revision 089901ee8ce49168ea8f8adca63057de93de5f95)
+++ uspace/lib/c/arch/sparc64/Makefile.inc	(revision 50805c9fe7d60aa26c79db6832302ee379195077)
@@ -37,5 +37,6 @@
 
 ARCH_AUTOGENS_AG = \
-	arch/$(UARCH)/include/libarch/istate_struct.ag
+	arch/$(UARCH)/include/libarch/istate_struct.ag \
+	arch/$(UARCH)/include/libarch/fibril_context.ag
 
 .PRECIOUS: arch/$(UARCH)/src/entry.o
Index: pace/lib/c/arch/sparc64/include/libarch/context_offset.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/context_offset.h	(revision 089901ee8ce49168ea8f8adca63057de93de5f95)
+++ 	(revision )
@@ -1,1 +1,0 @@
-../../../../../../../kernel/arch/sparc64/include/arch/context_offset.h
Index: uspace/lib/c/arch/sparc64/include/libarch/fibril.h
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/fibril.h	(revision 089901ee8ce49168ea8f8adca63057de93de5f95)
+++ uspace/lib/c/arch/sparc64/include/libarch/fibril.h	(revision 50805c9fe7d60aa26c79db6832302ee379195077)
@@ -37,4 +37,5 @@
 
 #include <libarch/stack.h>
+#include <libarch/fibril_context.h>
 #include <sys/types.h>
 #include <align.h>
@@ -51,30 +52,4 @@
 	} while (0)
 
-/*
- * Save only registers that must be preserved across
- * function calls.
- */
-typedef struct {
-	uintptr_t sp;		/* %o6 */
-	uintptr_t pc;		/* %o7 */
-	uint64_t i0;
-	uint64_t i1;
-	uint64_t i2;
-	uint64_t i3;
-	uint64_t i4;
-	uint64_t i5;
-	uintptr_t fp;		/* %i6 */
-	uintptr_t i7;
-	uint64_t l0;
-	uint64_t l1;
-	uint64_t l2;
-	uint64_t l3;
-	uint64_t l4;
-	uint64_t l5;
-	uint64_t l6;
-	uint64_t l7;
-	uint64_t tp;		/* %g7 */
-} context_t;
-
 static inline uintptr_t context_get_fp(context_t *ctx)
 {
Index: uspace/lib/c/arch/sparc64/include/libarch/fibril_context.ag
===================================================================
--- uspace/lib/c/arch/sparc64/include/libarch/fibril_context.ag	(revision 50805c9fe7d60aa26c79db6832302ee379195077)
+++ uspace/lib/c/arch/sparc64/include/libarch/fibril_context.ag	(revision 50805c9fe7d60aa26c79db6832302ee379195077)
@@ -0,0 +1,123 @@
+# Copyright (c) 2014 Jakub Jermar 
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+{
+        name : context,
+
+        includes : [
+                {
+                        include : <sys/types.h>
+                }
+        ],
+
+        #
+        # Save only registers that must be preserved across function calls.
+        #
+        members : [
+                {
+                        # %o6
+                        name : sp,
+                        type : uintptr_t
+                },
+                {
+                        # %o7
+                        name : pc,
+                        type : uintptr_t
+                },
+                {
+                        name : i0,
+                        type : uint64_t
+                },
+                {
+                        name : i1,
+                        type : uint64_t
+                },
+                {
+                        name : i2,
+                        type : uint64_t
+                },
+                {
+                        name : i3,
+                        type : uint64_t
+                },
+                {
+                        name : i4,
+                        type : uint64_t
+                },
+                {
+                        name : i5,
+                        type : uint64_t
+                },
+                {
+                        # %i6
+                        name : fp,
+                        type : uintptr_t
+                },
+                {
+                        name : i7,
+                        type : uintptr_t
+                },
+                {
+                        name : l0,
+                        type : uint64_t
+                },
+                {
+                        name : l1,
+                        type : uint64_t
+                },
+                {
+                        name : l2,
+                        type : uint64_t
+                },
+                {
+                        name : l3,
+                        type : uint64_t
+                },
+                {
+                        name : l4,
+                        type : uint64_t
+                },
+                {
+                        name : l5,
+                        type : uint64_t
+                },
+                {
+                        name : l6,
+                        type : uint64_t
+                },
+                {
+                        name : l7,
+                        type : uint64_t
+                },
+                {
+                        # %g7
+                        name : tp,
+                        type : uint64_t
+                }
+        ]
+}
+
Index: uspace/lib/c/arch/sparc64/src/fibril.S
===================================================================
--- uspace/lib/c/arch/sparc64/src/fibril.S	(revision 089901ee8ce49168ea8f8adca63057de93de5f95)
+++ uspace/lib/c/arch/sparc64/src/fibril.S	(revision 50805c9fe7d60aa26c79db6832302ee379195077)
@@ -27,5 +27,5 @@
 #
 
-#include <libarch/context_offset.h>
+#include <libarch/fibril_context.h>
 
 .text
@@ -39,5 +39,23 @@
 	# should a thread switch occur.
 	#
-	CONTEXT_SAVE_ARCH_CORE %o0
+	stx %sp, [%o0 + CONTEXT_OFFSET_SP]
+	stx %o7, [%o0 + CONTEXT_OFFSET_PC]
+	stx %i0, [%o0 + CONTEXT_OFFSET_I0]
+	stx %i1, [%o0 + CONTEXT_OFFSET_I1]
+	stx %i2, [%o0 + CONTEXT_OFFSET_I2]
+	stx %i3, [%o0 + CONTEXT_OFFSET_I3]
+	stx %i4, [%o0 + CONTEXT_OFFSET_I4]
+	stx %i5, [%o0 + CONTEXT_OFFSET_I5]
+	stx %fp, [%o0 + CONTEXT_OFFSET_FP]
+	stx %i7, [%o0 + CONTEXT_OFFSET_I7]
+	stx %l0, [%o0 + CONTEXT_OFFSET_L0]
+	stx %l1, [%o0 + CONTEXT_OFFSET_L1]
+	stx %l2, [%o0 + CONTEXT_OFFSET_L2]
+	stx %l3, [%o0 + CONTEXT_OFFSET_L3]
+	stx %l4, [%o0 + CONTEXT_OFFSET_L4]
+	stx %l5, [%o0 + CONTEXT_OFFSET_L5]
+	stx %l6, [%o0 + CONTEXT_OFFSET_L6]
+	stx %l7, [%o0 + CONTEXT_OFFSET_L7]
+	stx %g7, [%o0 + CONTEXT_OFFSET_TP]
 	retl
 	mov 1, %o0		! context_save_arch returns 1
@@ -52,5 +70,23 @@
 	flushw
 	
-	CONTEXT_RESTORE_ARCH_CORE %o0
+	ldx [%o0 + CONTEXT_OFFSET_SP], %sp
+	ldx [%o0 + CONTEXT_OFFSET_PC], %o7
+	ldx [%o0 + CONTEXT_OFFSET_I0], %i0
+	ldx [%o0 + CONTEXT_OFFSET_I1], %i1
+	ldx [%o0 + CONTEXT_OFFSET_I2], %i2
+	ldx [%o0 + CONTEXT_OFFSET_I3], %i3
+	ldx [%o0 + CONTEXT_OFFSET_I4], %i4
+	ldx [%o0 + CONTEXT_OFFSET_I5], %i5
+	ldx [%o0 + CONTEXT_OFFSET_FP], %fp
+	ldx [%o0 + CONTEXT_OFFSET_I7], %i7
+	ldx [%o0 + CONTEXT_OFFSET_L0], %l0
+	ldx [%o0 + CONTEXT_OFFSET_L1], %l1
+	ldx [%o0 + CONTEXT_OFFSET_L2], %l2
+	ldx [%o0 + CONTEXT_OFFSET_L3], %l3
+	ldx [%o0 + CONTEXT_OFFSET_L4], %l4
+	ldx [%o0 + CONTEXT_OFFSET_L5], %l5
+	ldx [%o0 + CONTEXT_OFFSET_L6], %l6
+	ldx [%o0 + CONTEXT_OFFSET_L7], %l7
+	ldx [%o0 + CONTEXT_OFFSET_TP], %g7
 	retl
 	xor %o0, %o0, %o0	! context_restore_arch returns 0