Index: .gitignore
===================================================================
--- .gitignore	(revision 56763a4d059724c128e20677b9e9a6eb78f91222)
+++ .gitignore	(revision 56763a4d059724c128e20677b9e9a6eb78f91222)
@@ -0,0 +1,421 @@
+*.disasm
+*.a
+*.o
+*.la
+*.lo
+*.map
+*.prev
+*.so.*
+*.d
+*.ag.probe.s
+*.ag.probe.c
+*.pyc
+tag
+deps.mk
+Makefile.ag.depend
+Makefile.common
+Makefile.config
+autotool/
+boot/distroot/
+boot/initrd.img
+common.h
+config.h
+cscope.out
+hdisk.img
+image.iso
+kernel/arch/amd64/_link.ld
+kernel/arch/amd64/include/arch/boot/memmap_struct.h
+kernel/arch/amd64/include/arch/common.h
+kernel/arch/amd64/include/arch/context_struct.h
+kernel/arch/amd64/include/arch/istate_struct.h
+kernel/arch/amd64/include/arch/kseg_struct.h
+kernel/arch/arm32/_link.ld
+kernel/arch/arm32/include/arch/context_struct.h
+kernel/arch/arm32/include/arch/istate_struct.h
+kernel/arch/ia32/_link.ld
+kernel/arch/ia32/include/arch/boot/memmap_struct.h
+kernel/arch/ia32/include/arch/context_struct.h
+kernel/arch/ia32/include/arch/istate_struct.h
+kernel/arch/ia64/include/arch/context_struct.h
+kernel/arch/ia64/include/arch/istate_struct.h
+kernel/arch/mips32/include/arch/context_struct.h
+kernel/arch/mips32/include/arch/fpu_context_struct.h
+kernel/arch/mips32/include/arch/istate_struct.h
+kernel/arch/ppc32/include/arch/context_struct.h
+kernel/arch/ppc32/include/arch/fpu_context_struct.h
+kernel/arch/ppc32/include/arch/istate_struct.h
+kernel/arch/sparc64/include/arch/context_struct.h
+kernel/arch/sparc64/include/arch/istate_struct.h
+kernel/genarch/include/genarch/multiboot/multiboot_info_struct.h
+kernel/genarch/include/genarch/multiboot/multiboot_memmap_struct.h
+kernel/generic/src/debug/real_map.bin
+kernel/kernel.bin
+kernel/kernel.dump
+kernel/kernel.raw
+uspace/app/barber/barber
+uspace/app/barber/images.c
+uspace/app/barber/images.h
+uspace/app/barber/images.s
+uspace/app/barber/images.zip
+uspace/app/barber/images_desc.c
+uspace/app/bdsh/bdsh
+uspace/app/bdsh/test-bdsh
+uspace/app/bithenge/bithenge
+uspace/app/blkdump/blkdump
+uspace/app/bnchmark/bnchmark
+uspace/app/corecfg/corecfg
+uspace/app/date/date
+uspace/app/devctl/devctl
+uspace/app/df/df
+uspace/app/dltest/dltest
+uspace/app/dltests/dltests
+uspace/app/dnscfg/dnscfg
+uspace/app/dnsres/dnsres
+uspace/app/download/download
+uspace/app/edit/edit
+uspace/app/fdisk/fdisk
+uspace/app/fontviewer/fontviewer
+uspace/app/getterm/getterm
+uspace/app/gunzip/gunzip
+uspace/app/inet/inet
+uspace/app/init/init
+uspace/app/kill/kill
+uspace/app/killall/killall
+uspace/app/kio/kio
+uspace/app/loc/loc
+uspace/app/logset/logset
+uspace/app/mixerctl/mixerctl
+uspace/app/mkbd/mkbd
+uspace/app/mkexfat/mkexfat
+uspace/app/mkfat/mkfat
+uspace/app/mkmfs/mkmfs
+uspace/app/modplay/modplay
+uspace/app/netecho/netecho
+uspace/app/netspeed/netspeed
+uspace/app/nettest1/nettest1
+uspace/app/nettest2/nettest2
+uspace/app/nettest3/nettest3
+uspace/app/nic/nic
+uspace/app/nterm/nterm
+uspace/app/ping/ping
+uspace/app/ping6/ping6
+uspace/app/pkg/pkg
+uspace/app/rcubench/rcubench
+uspace/app/rcutest/rcutest
+uspace/app/redir/redir
+uspace/app/sbi/sbi
+uspace/app/sportdmp/sportdmp
+uspace/app/stats/stats
+uspace/app/sysinfo/sysinfo
+uspace/app/sysinst/sysinst
+uspace/app/taskdump/taskdump
+uspace/app/tester/tester
+uspace/app/testread/testread
+uspace/app/testwrit/testwrit
+uspace/app/tetris/tetris
+uspace/app/top/top
+uspace/app/trace/trace
+uspace/app/untar/untar
+uspace/app/usbinfo/usbinfo
+uspace/app/vcalc/vcalc
+uspace/app/vdemo/vdemo
+uspace/app/viewer/viewer
+uspace/app/vlaunch/images.c
+uspace/app/vlaunch/images.h
+uspace/app/vlaunch/images.s
+uspace/app/vlaunch/images.zip
+uspace/app/vlaunch/images_desc.c
+uspace/app/vlaunch/vlaunch
+uspace/app/vterm/vterm
+uspace/app/vuhid/vuh
+uspace/app/wavplay/wavplay
+uspace/app/websrv/websrv
+uspace/app/wifi_supplicant/wifi_supplicant
+uspace/dist/app/barber
+uspace/dist/app/bdsh
+uspace/dist/app/bithenge
+uspace/dist/app/blkdump
+uspace/dist/app/bnchmark
+uspace/dist/app/corecfg
+uspace/dist/app/date
+uspace/dist/app/devctl
+uspace/dist/app/df
+uspace/dist/app/dltest
+uspace/dist/app/dltests
+uspace/dist/app/dnscfg
+uspace/dist/app/dnsres
+uspace/dist/app/download
+uspace/dist/app/edit
+uspace/dist/app/fdisk
+uspace/dist/app/fontviewer
+uspace/dist/app/getterm
+uspace/dist/app/gunzip
+uspace/dist/app/inet
+uspace/dist/app/kill
+uspace/dist/app/killall
+uspace/dist/app/kio
+uspace/dist/app/loc
+uspace/dist/app/logset
+uspace/dist/app/mixerctl
+uspace/dist/app/mkbd
+uspace/dist/app/mkexfat
+uspace/dist/app/mkfat
+uspace/dist/app/mkmfs
+uspace/dist/app/modplay
+uspace/dist/app/netecho
+uspace/dist/app/netspeed
+uspace/dist/app/nettest1
+uspace/dist/app/nettest2
+uspace/dist/app/nettest3
+uspace/dist/app/nic
+uspace/dist/app/nterm
+uspace/dist/app/ping
+uspace/dist/app/ping6
+uspace/dist/app/pkg
+uspace/dist/app/rcubench
+uspace/dist/app/rcutest
+uspace/dist/app/redir
+uspace/dist/app/sbi
+uspace/dist/app/sportdmp
+uspace/dist/app/stats
+uspace/dist/app/sysinfo
+uspace/dist/app/sysinst
+uspace/dist/app/taskdump
+uspace/dist/app/tester
+uspace/dist/app/testread
+uspace/dist/app/testwrit
+uspace/dist/app/tetris
+uspace/dist/app/top
+uspace/dist/app/trace
+uspace/dist/app/untar
+uspace/dist/app/usbinfo
+uspace/dist/app/vcalc
+uspace/dist/app/vdemo
+uspace/dist/app/viewer
+uspace/dist/app/vlaunch
+uspace/dist/app/vterm
+uspace/dist/app/vuh
+uspace/dist/app/wavplay
+uspace/dist/app/websrv
+uspace/dist/app/wifi_supplicant
+uspace/dist/demo.txt
+uspace/dist/demo.wav
+uspace/dist/demo.xm
+uspace/dist/drv/ahci/
+uspace/dist/drv/apic/
+uspace/dist/drv/ar9271/
+uspace/dist/drv/ata_bd/
+uspace/dist/drv/atkbd/
+uspace/dist/drv/cmos-rtc/
+uspace/dist/drv/e1k/
+uspace/dist/drv/ehci/
+uspace/dist/drv/hdaudio/
+uspace/dist/drv/i8042/
+uspace/dist/drv/i8259/
+uspace/dist/drv/icp/
+uspace/dist/drv/icp-ic/
+uspace/dist/drv/isa/
+uspace/dist/drv/kfb/
+uspace/dist/drv/msim-con/
+uspace/dist/drv/ne2k/
+uspace/dist/drv/ns8250/
+uspace/dist/drv/ohci/
+uspace/dist/drv/pc/
+uspace/dist/drv/pciintel/
+uspace/dist/drv/pl050/
+uspace/dist/drv/ps2mouse/
+uspace/dist/drv/root/
+uspace/dist/drv/rootpc/
+uspace/dist/drv/rtl8139/
+uspace/dist/drv/rtl8169/
+uspace/dist/drv/sb16/
+uspace/dist/drv/ski-con/
+uspace/dist/drv/sun4v-con/
+uspace/dist/drv/test1/
+uspace/dist/drv/test2/
+uspace/dist/drv/test3/
+uspace/dist/drv/uhci/
+uspace/dist/drv/usbflbk/
+uspace/dist/drv/usbhid/
+uspace/dist/drv/usbhub/
+uspace/dist/drv/usbmast/
+uspace/dist/drv/usbmid/
+uspace/dist/drv/vhc/
+uspace/dist/drv/virt/
+uspace/dist/drv/xtkbd/
+uspace/dist/inc/_link.ld
+uspace/dist/inc/c/
+uspace/dist/logo.tga
+uspace/dist/srv/cdfs
+uspace/dist/srv/clipboard
+uspace/dist/srv/compositor
+uspace/dist/srv/console
+uspace/dist/srv/devman
+uspace/dist/srv/dhcp
+uspace/dist/srv/dnsrsrv
+uspace/dist/srv/ethip
+uspace/dist/srv/exfat
+uspace/dist/srv/ext4fs
+uspace/dist/srv/fat
+uspace/dist/srv/file_bd
+uspace/dist/srv/hound
+uspace/dist/srv/inetsrv
+uspace/dist/srv/input
+uspace/dist/srv/isdv4_tablet
+uspace/dist/srv/klog
+uspace/dist/srv/locfs
+uspace/dist/srv/loopip
+uspace/dist/srv/mfs
+uspace/dist/srv/nconfsrv
+uspace/dist/srv/output
+uspace/dist/srv/remcons
+uspace/dist/srv/rfb
+uspace/dist/srv/sata_bd
+uspace/dist/srv/slip
+uspace/dist/srv/taskmon
+uspace/dist/srv/tcp
+uspace/dist/srv/tmpfs
+uspace/dist/srv/udf
+uspace/dist/srv/udp
+uspace/dist/srv/vbd
+uspace/dist/srv/volsrv
+uspace/dist/test/*
+uspace/drv/audio/hdaudio/hdaudio
+uspace/drv/audio/sb16/sb16
+uspace/drv/block/ahci/ahci
+uspace/drv/block/ata_bd/ata_bd
+uspace/drv/block/ddisk/ddisk
+uspace/drv/block/usbmast/usbmast
+uspace/drv/bus/adb/cuda_adb/cuda_adb
+uspace/drv/bus/isa/isa
+uspace/drv/bus/pci/pciintel/pciintel
+uspace/drv/bus/usb/ehci/ehci
+uspace/drv/bus/usb/ohci/ohci
+uspace/drv/bus/usb/uhci/uhci
+uspace/drv/bus/usb/usbflbk/usbflbk
+uspace/drv/bus/usb/usbhub/usbhub
+uspace/drv/bus/usb/usbmid/usbmid
+uspace/drv/bus/usb/vhc/vhc
+uspace/drv/char/i8042/i8042
+uspace/drv/char/msim-con/msim-con
+uspace/drv/char/ns8250/ns8250
+uspace/drv/char/pl050/pl050
+uspace/drv/char/ps2mouse/ps2mouse
+uspace/drv/char/ski-con/ski-con
+uspace/drv/char/sun4v-con/sun4v-con
+uspace/drv/fb/amdm37x_dispc/amdm37x_dispc
+uspace/drv/fb/kfb/kfb
+uspace/drv/hid/atkbd/atkbd
+uspace/drv/hid/xtkbd/xtkbd
+uspace/drv/hid/ps2mouse/ps2mouse
+uspace/drv/hid/usbhid/usbhid
+uspace/drv/intctl/apic/apic
+uspace/drv/intctl/i8259/i8259
+uspace/drv/intctl/icp-ic/icp-ic
+uspace/drv/intctl/obio/obio
+uspace/drv/nic/ar9271/ar9271
+uspace/drv/nic/e1k/e1k
+uspace/drv/nic/ne2k/ne2k
+uspace/drv/nic/rtl8139/rtl8139
+uspace/drv/nic/rtl8169/rtl8169
+uspace/drv/platform/amdm37x/amdm37x
+uspace/drv/platform/icp/icp
+uspace/drv/platform/mac/mac
+uspace/drv/platform/malta/malta
+uspace/drv/platform/msim/msim
+uspace/drv/platform/pc/pc
+uspace/drv/platform/rootpc/rootpc
+uspace/drv/platform/ski/ski
+uspace/drv/platform/sun4v/sun4v
+uspace/drv/root/root/root
+uspace/drv/root/virt/virt
+uspace/drv/test/test1/test1
+uspace/drv/test/test2/test2
+uspace/drv/test/test3/test3
+uspace/drv/time/cmos-rtc/cmos-rtc
+uspace/lib/c/arch/amd64/_link-dlexe.ld
+uspace/lib/c/arch/amd64/_link-loader.ld
+uspace/lib/c/arch/amd64/_link-shlib.ld
+uspace/lib/c/arch/amd64/_link.ld
+uspace/lib/c/arch/amd64/include/libarch/common.h
+uspace/lib/c/arch/amd64/include/libarch/fibril_context.h
+uspace/lib/c/arch/amd64/include/libarch/istate_struct.h
+uspace/lib/c/arch/arm32/_link-dlexe.ld
+uspace/lib/c/arch/arm32/_link-loader.ld
+uspace/lib/c/arch/arm32/_link-shlib.ld
+uspace/lib/c/arch/arm32/_link.ld
+uspace/lib/c/arch/arm32/include/libarch/fibril_context.h
+uspace/lib/c/arch/arm32/include/libarch/istate_struct.h
+uspace/lib/c/arch/ia32/_link-dlexe.ld
+uspace/lib/c/arch/ia32/_link-loader.ld
+uspace/lib/c/arch/ia32/_link-shlib.ld
+uspace/lib/c/arch/ia32/_link.ld
+uspace/lib/c/arch/ia32/include/libarch/fibril_context.h
+uspace/lib/c/arch/ia32/include/libarch/istate_struct.h
+uspace/lib/c/arch/ia64/include/libarch/fibril_context.h
+uspace/lib/c/arch/ia64/include/libarch/istate_struct.h
+uspace/lib/c/arch/mips32/include/libarch/fibril_context.h
+uspace/lib/c/arch/mips32/include/libarch/istate_struct.h
+uspace/lib/c/arch/mips32eb/include/libarch/fibril_context.h
+uspace/lib/c/arch/mips32eb/include/libarch/istate_struct.h
+uspace/lib/c/arch/ppc32/include/libarch/fibril_context.h
+uspace/lib/c/arch/ppc32/include/libarch/istate_struct.h
+uspace/lib/c/arch/sparc64/include/libarch/fibril_context.h
+uspace/lib/c/arch/sparc64/include/libarch/istate_struct.h
+uspace/lib/c/test-libc
+uspace/lib/label/test-liblabel
+uspace/lib/pcut/test-libpcut-*
+uspace/lib/posix/collisions.list
+uspace/lib/posix/include/libc
+uspace/lib/posix/redefs-hide-libc-symbols.list
+uspace/lib/posix/redefs-hide-libc.xargs
+uspace/lib/posix/redefs-show-posix-symbols.list
+uspace/lib/posix/redefs-show-posix.xargs
+uspace/lib/posix/test-libposix
+uspace/lib/uri/test-liburi
+uspace/srv/audio/hound/hound
+uspace/srv/bd/file_bd/file_bd
+uspace/srv/bd/rd/rd
+uspace/srv/bd/sata_bd/sata_bd
+uspace/srv/bd/vbd/vbd
+uspace/srv/clipboard/clipboard
+uspace/srv/devman/devman
+uspace/srv/fs/cdfs/cdfs
+uspace/srv/fs/exfat/exfat
+uspace/srv/fs/ext4fs/ext4fs
+uspace/srv/fs/fat/fat
+uspace/srv/fs/locfs/locfs
+uspace/srv/fs/mfs/mfs
+uspace/srv/fs/tmpfs/tmpfs
+uspace/srv/fs/udf/udf
+uspace/srv/hid/compositor/compositor
+uspace/srv/hid/compositor/images.c
+uspace/srv/hid/compositor/images.h
+uspace/srv/hid/console/console
+uspace/srv/hid/input/input
+uspace/srv/hid/isdv4_tablet/isdv4_tablet
+uspace/srv/hid/output/output
+uspace/srv/hid/remcons/remcons
+uspace/srv/hid/rfb/rfb
+uspace/srv/hid/s3c24xx_ts/s3c24xx_ts
+uspace/srv/hw/bus/cuda_adb/cuda_adb
+uspace/srv/hw/char/s3c24xx_uart/s3c24ser
+uspace/srv/hw/irc/obio/obio
+uspace/srv/klog/klog
+uspace/srv/loader/loader
+uspace/srv/locsrv/locsrv
+uspace/srv/logger/logger
+uspace/srv/net/dhcp/dhcp
+uspace/srv/net/dnsrsrv/dnsrsrv
+uspace/srv/net/ethip/ethip
+uspace/srv/net/inetsrv/inetsrv
+uspace/srv/net/loopip/loopip
+uspace/srv/net/nconfsrv/nconfsrv
+uspace/srv/net/slip/slip
+uspace/srv/net/tcp/tcp
+uspace/srv/net/tcp/test-tcp
+uspace/srv/net/udp/udp
+uspace/srv/ns/ns
+uspace/srv/taskmon/taskmon
+uspace/srv/vfs/vfs
+uspace/srv/volsrv/volsrv